#ifndef LIB_DBG_PERF_COUNTER_DISABLE_MQH_INCLUDED
#define LIB_DBG_PERF_COUNTER_DISABLE_MQH_INCLUDED
#property version   "5.10"
/**********************************************************************************
 * Copyright (C) 2020 Dominik Egert <info@freie-netze.de>
 *
 * This file is the performance cuonter unloader/disable include file.
 *
 * Lisence applied: GPLv2
 *                  https://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 *
 * Author Dominik Egert / Freie Netze UG.
 **********************************************************************************
 *
 *  Version: 5.10
 *  State: public
 *
 *  File information
 *  ================
 *
 *
 *
*/




/////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Remove performance profiling support
//

#ifndef LIB_PERF_PROFILING

    // Remove all performance collector code
    #ifndef PERF_COUNTER_DEFINE_ID
        #define PERF_COUNTER_DEFINE_ID(x)

    #endif

    #ifndef PERF_COUNTER_BEGIN_ID
        #define PERF_COUNTER_BEGIN_ID(x)

    #endif

    #ifndef PERF_COUNTER_END_ID
        #define PERF_COUNTER_END_ID(x)

    #endif

    #ifndef PERF_COUNTER_CLOSE
        #define PERF_COUNTER_CLOSE(x)

    #endif

    #ifndef PERF_COUNTER_BEGIN
        #define PERF_COUNTER_BEGIN

    #endif

    #ifndef PERF_COUNTER_END
        #define PERF_COUNTER_END

    #endif

    #ifndef PERF_COUNTER_TIMEIT_V
        #define PERF_COUNTER_TIMEIT_V(x)    x

    #endif

    #ifndef PERF_COUNTER_TIMEIT_R
        #define PERF_COUNTER_TIMEIT_R(x)    x

    #endif

    #ifndef PERF_COUNTER_TIMEIT_O
        #define PERF_COUNTER_TIMEIT_O(x)    x

    #endif

#endif

//
/////////////////////////////////////////////////////////////////////////////////////////////////////



//
// END Debugging support
//*********************************************************************************************************************************************************/
#endif // LIB_DBG_PERF_COUNTER_DISABLE_MQH_INCLUDED
